-- Test set_campsite_type_option_cost
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'set_campsite_type_option_cost', array['integer', 'integer', 'text', 'integer']);
select function_lang_is('camper', 'set_campsite_type_option_cost', array['integer', 'integer', 'text', 'integer'], 'sql');
select function_returns('camper', 'set_campsite_type_option_cost', array['integer', 'integer', 'text', 'integer'], 'void');
select isnt_definer('camper', 'set_campsite_type_option_cost', array['integer', 'integer', 'text', 'integer']);
select volatility_is('camper', 'set_campsite_type_option_cost', array['integer', 'integer', 'text', 'integer'], 'volatile');
select function_privs_are('camper', 'set_campsite_type_option_cost', array ['integer', 'integer', 'text', 'integer'], 'guest', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_option_cost', array ['integer', 'integer', 'text', 'integer'], 'employee', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_option_cost', array ['integer', 'integer', 'text', 'integer'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'set_campsite_type_option_cost', array ['integer', 'integer', 'text', 'integer'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_option_cost cascade;
truncate season cascade;
truncate campsite_type_option cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (3, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '', 5, '[1, 7]', true)
;

insert into season (season_id, company_id, name)
values (4, 1, 'High')
     , (5, 1, 'Mid')
     , (6, 1, 'Low')
;

insert into campsite_type_option (campsite_type_option_id, campsite_type_id, name, range, per_night)
values (7, 3, 'Test Option', '[1, 100]', true)
;

insert into campsite_type_option_cost (campsite_type_option_id, season_id, cost)
values (7, 4, 44)
     , (7, 5, 55)
;

select lives_ok(
	$$ select set_campsite_type_option_cost(7, 4, '12.34') $$,
	'Should be able to edit the cost for high season'
);

select lives_ok(
	$$ select set_campsite_type_option_cost(7, 5, '0.0') $$,
	'Should be able to set the cost for mid season to zero'
);

select lives_ok(
	$$ select set_campsite_type_option_cost(7, 6, '3.21') $$,
	'Should be able to set the cost for low season, inserting it.'
);

select bag_eq(
	$$ select campsite_type_option_id, season_id, cost from campsite_type_option_cost $$,
	$$ values (7, 4, 1234)
	        , (7, 5,    0)
	        , (7, 6,  321)
	$$,
	'Should have updated all option costs.'
);


select *
from finish();

rollback;
